commit 0c6cd06565e67810199cfe8eb42be994ecab5142
Author: jklowden <jklowden>
Date:   Mon Dec 8 22:44:26 2008 +0000

    initial version

diff --git a/samples/odbcfunc.pl b/samples/odbcfunc.pl
new file mode 100755
index 0000000..3ab49ac
--- /dev/null
+++ b/samples/odbcfunc.pl
@@ -0,0 +1,95 @@
+#! /usr/bin/perl -w
+
+# List supported/unsupported functions for an ODBC data source
+
+# Contributed to the public domain by James K. Lowden
+# $Id: odbcfunc.pl,v 1.1 2008/12/08 22:44:26 jklowden Exp $
+
+use Getopt::Std;
+use File::Basename;
+use DBI;
+use DBI::Const::GetInfoType;
+
+getopts( 'I:P:S:U:v:', \%opts );
+
+$opts{v} = 0 unless defined($opts{v});
+
+$server = $opts{S} 
+	or die basename($0) . qq(: need -S server (DSN) name\n);
+
+$dsn = qq(dbi:ODBC:$server) 
+	or die qq(could not connect to ODBC Data Source "$server"\n);
+
+my ($username, $passwd) = ($opts{U}, $opts{P});
+
+$dbh = DBI->connect($dsn, $username, $passwd, undef);
+
+print "Available ODBC Constants:\n", join($/, keys %GetInfoType), $/
+	if $opts{v} == 1;
+
+$sql_h_path = "C:/Program Files/Microsoft SQL Server/80/Tools/DevTools/Include";
+$sql_h_path = $opts{I} if defined($opts{I});
+
+# 
+# Build list of SQL_API constants from include files. 
+#
+foreach my $file (('sql.h', 'sqlext.h')) {
+	$sql_h_file = "$sql_h_path/$file";
+	open SQLH, "$sql_h_file" or die "could not open $sql_h_file\n";
+
+	while( <SQLH> ) {
+		next unless s/SQL_API_//;
+		my ($define, $name, $value) = split;
+		if( defined($api{$value}) ) {
+			printf STDERR "overwriting %d (%s) with %s in $file\n", 
+				$value, $api{$value}, $name, $file;
+		}
+		$api{$value} = $name;
+	}
+}
+
+die unless %api;
+
+# Capture array of supported/unsupported by SQL_API index value. 
+my @supported = $dbh->func(0, "GetFunctions");
+
+# Map names to supported/unsupported 
+for ($api=1; $api < 100; $api++) {
+	next if( !$supported[$api] && !$api{$api} ); 
+	local $^W;
+	$^W = 0;
+	printf "%4d:\t%-30s\t%s supported\n", $api, $api{$api}, $supported[$api]? '   ':'not'
+		if $opts{v} == 2;
+	$functions{$api{$api}} = $supported[$api]? 'supported' : 'unsupported';
+}
+
+# Print names, sorted
+foreach my $name (sort keys %functions) {
+	printf "%-30s\t%s\n", $name, $functions{$name};
+}
+
+__END__
+
+=head1 NAME
+
+odbcfunc - List ODBC functions supported (and unsupported) by an ODBC driver. 
+
+=head1 SYNOPSIS
+
+	odbcfunc.pl -S DSN [-U username] [-P passwd] [-v verbosity]
+
+=head1 DESCRIPTION
+
+Prints results from the ODBC function SQLGetFunctions.  
+
+=head1 OPTIONS
+
+=over 
+
+=item -S DSN is a Data Source Name that uses the driver. 
+
+=item -U is a username, if required. 
+
+=item -P is a password, if required. 
+
+=item -v may have a value of 1 or 2, which prints more details. 
diff --git a/samples/odbschema.pl b/samples/odbschema.pl
new file mode 100755
index 0000000..c2ccd79
--- /dev/null
+++ b/samples/odbschema.pl
@@ -0,0 +1,135 @@
+#! /usr/bin/perl -w
+
+# List DDL for an ODBC data source
+
+# Contributed to the public domain by James K. Lowden
+# Inspired by the much more sophisticated dbschema by Michael Peppler, et al.
+# $Id: odbschema.pl,v 1.1 2008/12/08 22:44:26 jklowden Exp $
+
+use Getopt::Std;
+use File::Basename;
+use DBI;
+use DBI::Const::GetInfoType;
+
+getopts( 'S:v:X', \%opts );
+
+$opts{v} = 0 unless defined($opts{v});
+
+# print environment information, to help know what can be connected to
+if( $opts{v} == 3 ) {
+	print "Available drivers:\n", join($/, DBI->available_drivers, $/);
+	print "Available ODBC Data Sources:\n", join($/, DBI->data_sources('ODBC', undef), $/);
+	print "Available ODBC Constants:\n", join($/, keys %GetInfoType), $/;
+}
+
+$server = $opts{S} 
+	or die basename($0) . qq(: need -S server (DSN) name\n);
+
+$dsn = qq(dbi:ODBC:$server) 
+	or die qq(could not connect to ODBC Data Source "$server"\n);
+
+my ($username, $auth);
+
+$dbh = DBI->connect($dsn, $username, $auth, undef);
+
+# get tables
+$sth = $dbh->table_info('%', '', '');
+while ( @row = $sth->fetchrow_array ) {
+	if( $opts{v} == 2 ) {
+		print '[', join('], [', @row), ']', $/;
+	}
+	next unless $row[3] eq 'TABLE';
+	push @tables, $row[2];
+	$catalogs{$row[0]}++;
+}
+
+die if 1 < keys %catalogs;
+
+($catalog) = keys %catalogs;
+$schema = '';
+$fGetKeys = 1;
+
+# set LongReadLen to something more than 80 if extracting data. 
+if( $opts{X} ) {
+	printf STDERR qq("LongReadLen" is %d\n), $dbh->{LongReadLen};
+	$dbh->{LongReadLen} = 640;
+	printf STDERR qq("LongReadLen" is %d\n), $dbh->{LongReadLen};
+}
+
+foreach my $table (@tables) {
+	if( $fGetKeys ) {
+		my $ksth = $dbh->primary_key_info( $catalog, $schema, $table ); 
+		if( !defined($ksth) ) {
+			warn "warning: primary_key_info failed for $catalog.$schema.$table, "
+				 . "no primary keys will be extracted for this schema.\n";
+			$fGetKeys = 0;
+			goto GetColumns;
+		}
+
+		# get primary key columns
+		my $c = 0;
+		my @key = ();
+		while ( $rrow = $ksth->fetchrow_hashref ) {
+			my $pkname = defined($rrow->{PK_NAME})? $rrow->{PK_NAME} : '';
+			$rrow->{KEY_SEQ} == ++$c 
+				or die "KEY_SEQ $rrow->{KEY_SEQ} != $c\n";
+			push @key, $rrow->{COLUMN_NAME};
+		}
+	}
+
+	#
+	GetColumns:
+	#
+	my $column = '%';
+	$sth = $dbh->column_info( $catalog, $schema, $table, $column ) 
+		or die "error: column_info failed\n";
+
+	printf "create table [%s]\n", $table;
+
+	# get columns
+	my $comma = '(';
+	while ( $rrow = $sth->fetchrow_hashref ) {
+		my $nullable = $rrow->{NULLABLE}? '    NULL' : 'not NULL';
+		my $type = $rrow->{TYPE_NAME};
+		$type .= "($rrow->{CHAR_OCTET_LENGTH})" if $rrow->{CHAR_OCTET_LENGTH};
+		printf "\t$comma [%-30s] %-15s %s -- %3d\n", 
+			$rrow->{COLUMN_NAME}, $type, $nullable, $rrow->{ORDINAL_POSITION};
+		$comma = ',';
+	}
+	if( $key ) {
+		printf "\t, PRIMARY KEY (%s)\n", join ', ', @key;
+	}
+	printf "\t);\n\n";
+
+	if( $opts{X} ) {
+		extract_data($table);
+	}
+}
+
+sub extract_data
+{ my $table = $_[0];
+
+	my $filename = $table;
+	$filename =~ s/[<>\ ]//g;
+	open DAT, ">$filename.dat" 
+		or die qq(error: could not open "$filename.dat" (table: $table)\n);
+
+	my $statement = "select * from [$table]";
+
+	my $sth = $dbh->prepare($statement) 
+		or die qq(error: could not prepare "$statement"\n);
+
+	$sth->execute() or die;
+
+	local $^W;
+	$^W = 0;
+	my @row;
+	while ( @row = $sth->fetchrow_array ) {
+			die if grep /\t/, @row;
+			print DAT join("\t", @row), $/;
+	}
+}
+	
+
+
+__END__

